# S1 - Native File Format Deconstruction

Stage One, or "S1" for short is the first stage in LLO. This stage deconstructs native files and creates an IL version of them called "Low Level Obfuscation Intermediate File Format" or LLOIFF for short. This branch of the repository is mearly a proposal for the composition of S1 and is entirely subject to change. 

### File Format Deconstructors - dctors

The term "dctor" is typically refered to class deconstructors, however in the usage in this proposal it refers to file format deconstruction. I went with the "strategy pattern" with my file format deconstruction. 

```
In computer programming, the strategy pattern is a behavioral software design pattern that enables selecting an algorithm at runtime. Instead of implementing a single algorithm directly, code receives run-time instructions as to which in a family of algorithms to use.

- https://en.wikipedia.org/wiki/Strategy_pattern
```

This is ideal for deconstruction algorithms as there can be different files to deconstruct and thus different algorithms must run.
